<template>
    <div v-if="isLoading" class="flex w-full h-full">
        <div v-loading="isLoading" class="w-full px-5 py-32"></div>
    </div>
    <template v-else>
        <div v-if="!isBankMethodAvailabled" class="px-5 py-32 text-2xl flex justify-center">
            <span>{{ $t("no_available_method_to_do_the_transaction") }}</span>
        </div>
        <template v-else>
            <div v-if="!isLoading" class="divider-x flex relative mx-auto customeBK8">
                <aside class="min-w-[248px] w-3/12 bk8-scrollbar">
                    <el-scrollbar>
                        <div class="p-6 flex flex-col gap-4">
                            <template v-for="tab in tabs" :key="tab.to">
                                <nuxt-link v-if="tab.display"
                                    :to="tab.to"
                                    :class="{ selected: checkActiveLink(tab.to) }">
                                    <ui-check-button :text="$t(tab.label)" :img="tab.icon" />
                                </nuxt-link>
                            </template>
                        </div>
                    </el-scrollbar>
                </aside>
                <el-scrollbar class="w-9/12" height="724px">
                    <div class="divider-y">
                        <lazy-theme-common-desktop-payment-deposit-normal-bank-transfer-deposit 
                            :profile="profile" :normal-banks="normalBanks" 
                            v-if="$route.fullPath.includes('uc=/deposit/bank-transfer')"
                        />
                        <lazy-theme-common-desktop-payment-deposit-auto-deposit
                            :profile="profile" :normal-banks="normalBanks" 
                            v-else-if="$route.fullPath.includes('uc=/deposit/auto-deposit')"
                        />
                        <lazy-theme-common-desktop-payment-deposit-manual-crypto-currency-deposit
                            :manual-crypto-currency="manualCryptoCurrency"
                            :profile="profile"
                            v-else-if="$route.fullPath.includes('uc=/deposit/manual-crypto-currency')" 
                        />
                        <lazy-user-center-desktop-deposit-payment-bank-method 
                            :profile="profile" :payment-banks="paymentBanks"
                            v-else-if="$route.fullPath.includes('uc=/deposit/payment-bank/')" 
                        />
                    </div>
                </el-scrollbar>
            </div>
        </template>
    </template>
</template>
<script lang="ts" setup>
import { IPaymentMethodsForDepositAndWithdrawal } from "~~/models/getPaymentGatewayBanksRespone";

const {
    paymentBanks,
    normalBanks,
    manualCryptoCurrency,
    isNormalBankMethodEnabled,
    isPaymentBankMethodEnabled,
    isManualCryptoCurrencyEnabled,
    isLoading,
    IsAutoDepositEnabled,
    isBankMethodAvailabled,
} = useDeposit();
const { profile } = useProfile();
const { getAssetImage } = commonHelper;
type TDepositTab = {
    to: string,
    label: string,
    icon: string,
    display: boolean,
}
const tabs = ref<TDepositTab[]>([]);
const route = useRoute();
watch(()=> [paymentBanks.value, isPaymentBankMethodEnabled.value, isNormalBankMethodEnabled.value, isManualCryptoCurrencyEnabled.value, IsAutoDepositEnabled.value], ()=> {
    tabs.value = [];
    if (isPaymentBankMethodEnabled.value) {
        paymentBanks.value.PaymentMethodsForDeposit.forEach((paymentMethod: IPaymentMethodsForDepositAndWithdrawal) => {
            tabs.value.push({
                to: `${route.path}?uc=/deposit/payment-bank/${paymentMethod.PaymentMethod}`,
                label: paymentMethod.PaymentMethodDisplayName,
                icon: paymentMethod.PaymentMethodIconUrl,
                display: isPaymentBankMethodEnabled.value,
            });
        });
    }
    tabs.value.push({
        to: `${route.path}?uc=/deposit/bank-transfer`,
        label: 'bank_transfer',
        icon: getAssetImage('assets/materials/paymentMethod/icon-bank-transfer@2x.png'),
        display: isNormalBankMethodEnabled.value,
    });
    tabs.value.push({
        to: `${route.path}?uc=/deposit/manual-crypto-currency`,
        label: 'manual_crypto_currency',
        icon: getAssetImage('assets/materials/paymentMethod/icon-manual-crypto-currency@2x.png'),
        display: isManualCryptoCurrencyEnabled.value,
    });
    tabs.value.push({
        to: `${route.path}?uc=/deposit/auto-deposit`,
        label: 'auto_deposit',
        icon: getAssetImage('assets/materials/paymentMethod/icon-internet-banking@2x.png'),
        display: IsAutoDepositEnabled.value,
    });

})
const checkActiveLink = (link: string) => {
  return String(route.query?.uc) === link.replace('/?uc=', '');
};

</script>
<style scoped>
.uc-section :deep(.el-input__inner),
.uc-section :deep(.el-input.is-disabled .el-input__inner),
.uc-section :deep(.el-input-group__append) {
    background-color: rgba(0, 0, 0, 0.1);
    color: var(--text5);
}

:deep(.company-bank-account .el-input__wrapper) {
    width: 98%;
}

.uc-section :deep(.company-bank-account-container .el-input-group__append) {
    background-color: var(--primary);
    border: unset;
    border-radius: 4px;
    box-shadow: none;
}

.uc-section :deep(.el-form-item__label) {
    color: var(--text5);
}
</style>